/*
 *  $Id: comm_util.c,v 1.7 1994/02/02 22:29:53 lusk Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPIR_Comm_make_coll - make a hidden collective communicator

@*/
int MPIR_Comm_make_coll ( comm )
MPI_Comm comm;
{
  MPI_Comm new_comm = NEW(MPIR_COMMUNICATOR);
  new_comm->comm_type       = comm->comm_type;
  new_comm->group           = comm->group;
  new_comm->send_context    = new_comm->recv_context = comm->send_context + 1;
  new_comm->attr_cache      = comm->attr_cache;
  new_comm->comm_cache      = comm->comm_cache;
  comm->comm_coll           = new_comm;
  return(MPI_SUCCESS);
}


/*+

MPIR_Comm_N2_prev - retrieve greatest power of two < size of Comm.

+*/
int MPIR_Comm_N2_prev ( comm, N2_prev )
MPI_Comm comm;
int              *N2_prev;
{
  (*N2_prev) = comm->group->N2_prev;
  return (MPI_SUCCESS);
}
