/*
 *  $Id: irecv.c,v 1.8 1994/01/10 23:13:46 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: irecv.c,v 1.8 1994/01/10 23:13:46 gropp Exp $";
#endif /* lint */

#include "mpi.h"

/*@
    MPI_Irecv - 
@*/
int MPI_Irecv( start, count, datatype, source, tag, comm, handle )
void             *start;
int              count;
MPI_Datatype     datatype;
int              source;
int              tag;
MPI_Comm comm;
MPI_Comm_request *handle;
{
    if (source != MPI_PROCNULL)
    {
	MPI_Comm_Init( handle, datatype, source, tag, comm,
		      MPI_RECV, MPI_PERSISTENT);
	(*handle)->rhandle.bufadd = start;
	(*handle)->rhandle.count = count;
	MPI_Start( *handle );
    }
    else 
	*handle = 0;
    return MPI_OK;
}
