/*
 *  $Id: testany.c,v 1.9 1994/01/31 23:38:30 lusk Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include "mpi.h"
#include "mpisys.h"

/*@
    MPI_Testany - 
@*/
int MPI_Testany( count, handles, index, status )
int        count;
MPI_Comm_request handles[];
int        *index;
MPI_Status *status;
{
    int i, found;

    MPID_check_device( 0 );
    found = 0;
    for (i = 0; i < count; i++)
    {
	if ( handles[i] != NULL )
  	if ( handles[i]->chandle.completed == YES) {
	    found         = 1;
	    *index        = i;
	    if ( handles[i]->type == MPIR_SEND ) {
		MPID_complete_send( &handles[i]->shandle, status );
	        }
	    else {
		MPID_complete_recv( &handles[i]->rhandle );

		status->source = handles[i]->rhandle.source;
		status->tag    = handles[i]->rhandle.tag;
		status->count  = handles[i]->rhandle.actcount;
	    }
 	    MPI_Commreq_free( handles[i] ); /* Spec requires, but... */
 	    handles[i]    = NULL;
	    break;
        }
    }
    if ( !found )
	*index = -1;
    return MPI_OK;
}
