/*
 *  $Id: map_graph.c,v 1.5 1994/01/25 21:58:02 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Map_graph - map process to graph topology information

@*/
int MPI_Map_graph ( comm_old, nnodes, index, edges, newrank )
MPI_Comm comm_old;
int      nnodes;
int     *index;
int     *edges;
int     *newrank;
{
  int i;
  int nranks;
  int rank;
  int errno = MPI_SUCCESS;

  /* Check for valid arguments */
  if (((comm_old == (MPI_Comm)0) && (errno = MPI_ERR_COMM_NULL)) ||
      ((nnodes   <  1)           && (errno = MPI_ERR_UNKNOWN))   ||
      ((newrank  == (int *)0)    && (errno = MPI_ERR_NULL))      ||
      ((index    == (int *)0)    && (errno = MPI_ERR_NULL))      ||
      ((edges    == (int *)0)    && (errno = MPI_ERR_NULL))       )
    return (errno);
  
  /* Am I in this topology? */
  MPI_Comm_rank ( comm_old, &rank );
  if ( rank < nnodes )
    (*newrank) = rank;
  else
    (*newrank) = MPI_UNDEFINED;

  return (errno);
}
